﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;

using Microsoft.SqlServer.Types;

namespace VirtualEarthSpatialApp
{
	[DataContract]
	public class Customer
	{
		[DataMember]
		public string Name { get; set; }

		[DataMember]
		public string Company { get; set; }

		[DataMember]
		public double Latitude { get; set; }

		[DataMember]
		public double Longitude { get; set; }
	}
	
	[ServiceContract(Namespace = "VirtualEarthSpatialApp")]
	[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
	public class CustomerGeoService
	{
		private const string ConnStr =
			"Data Source=.;Initial Catalog=MyDb;Integrated Security=True;";

		[OperationContract]
		public List<Customer> GetCustomers()
		{
			var customers = new List<Customer>();

			using (var conn = new SqlConnection())
			{
				conn.ConnectionString = ConnStr;
				conn.Open();

				using (var cmd = new SqlCommand())
				{
					cmd.Connection = conn;
					cmd.CommandText = "GetCustomers";
					cmd.CommandType = CommandType.StoredProcedure;

					using (var rdr = cmd.ExecuteReader())
					{
						while (rdr.Read())
						{
							var customer = new Customer();
							customer.Name = rdr["Name"].ToString();
							customer.Company = rdr["Company"].ToString();

//            var geo = (SqlGeography)rdr["CustomerGeo"];  // Used to work before CTP3 (and still should!)
              var geo = SqlGeography.Deserialize(rdr.GetSqlBytes(2));
              customer.Latitude = (double)geo.Lat;
							customer.Longitude = (double)geo.Long;

							customers.Add(customer);
						}
						rdr.Close();
					}
				}

				conn.Close();

				return customers;
			}

		}
	}
}
